//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  \[X̃rbg}bv擾Tv
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N1124 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    Image1: TImage;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
    FResouceFile : string;
  public
    { Public 錾 }
  end;

function EnumResNameProc(hModule: HWND; lpszType: PChar; lpszName:PChar;
  AIndex: LPARAM): LongBool; stdcall;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'C:\Program Files (x86)\Embarcadero\RAD Studio\8.0\bin\dclstd150.bpl';
  Image1.AutoSize :=True;
end;

//=============================================================================
//  \[X̗
//  ł RT_BITMAP Ƃ(܂rbg}bv)
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LhModule : THandle;
  LdwFlag  : Cardinal;
begin
  Image1.Picture.Assign(nil);
  ListBox1.Items.Clear;
  ListBox1.Items.BeginUpdate;

  //\[Xt@Cw肵ăW[̃nh擾
  FResouceFile := ExpandFileName(Trim(Edit1.Text));
  LdwFlag      := LOAD_LIBRARY_AS_DATAFILE or LOAD_WITH_ALTERED_SEARCH_PATH;
  LhModule     := LoadLibraryEx(PChar(FResouceFile), 0, LdwFlag);
  try
   if LhModule <> 0 then begin
     //\[XID
     EnumResourceNames(LhModule, RT_BITMAP, @EnumResNameProc, -1);
   end;
   Label1.Caption := IntToStr(ListBox1.Items.Count);
  finally
    FreeLibrary(LhModule);
    ListBox1.Items.EndUpdate;
  end;
end;

//=============================================================================
//  ListBox1OnClickCxg
//  Xg{bNXItemNbN炻̃\[XǂݏoTImageɕ\
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
var
  LdwFlag  : Cardinal;
  LhModule : THandle;
  LItemStr : string;
  LItemInt : Integer;
  LBitmap  : TBitmap;
begin
  Image1.Picture.Assign(nil);@
  if ListBox1.ItemIndex =-1 then Exit;

  //\[Xt@Cw肵ăW[̃nh擾
  LdwFlag  := LOAD_LIBRARY_AS_DATAFILE or LOAD_WITH_ALTERED_SEARCH_PATH;
  LhModule := LoadLibraryEx(PChar(FResouceFile), 0, LdwFlag);
  try
  @if LhModule <> 0 then begin
      LBitmap := TBitmap.Create;
      try
        LItemStr := ListBox1.Items[ListBox1.ItemIndex];
        LItemInt := StrToIntDef(LItemStr, -1);

        //\[XIDl̎ƕ̎ŏ𕪊
        //񂪐ō\ĂƐlƔ肵Ă܂
        if LItemInt < 0 then begin
          LBitmap.LoadFromResourceName(LhModule, LItemStr);;
        end else begin
          LBitmap.LoadFromResourceID(LhModule, LItemInt);
        end;

        Image1.Picture.Bitmap.Assign(LBitmap);
      finally
        //LBitmap.HandleHBitmapĂ̂DeleteObject(LhBitmap)͕sv
        FreeAndNil(LBitmap);
      end;
    end;
  finally
    FreeLibrary(LhModule);
  end;
end;

//-----------------------------------------------------------------------------
//  EnumResourceNames̃R[obN֐
//  \[X̗
//-----------------------------------------------------------------------------
function EnumResNameProc(hModule: HWND; lpszType: PChar; lpszName: PChar;
  AIndex: LPARAM): LongBool;
var
  LhBitmap  : HBitmap;
  LResIDStr : string;
begin
  Result := True;

  if AIndex = -1 then begin
    //\[X̎擾
    LhBitmap := LoadImage(hModule, MakeIntResource(lpszName), IMAGE_BITMAP, 0, 0, 0);
    try
      if LhBitmap <> 0 then begin

        //\[X̃`FbN
        //WORD(2oCg) 0ȂID͐l.ȊÕ͕|C^
        if HiWord(Cardinal(lpszName)) = 0 then begin
          LResIDStr := IntToStr(Cardinal(lpszName));
        end else begin
          LResIDStr := lpszName;
        end;

        //\[XIDXgɒǉ
        Form1.ListBox1.Items.Add(LResIDStr);
      end;
    finally
      DeleteObject(LhBitmap);
    end;
  end;
end;

end.
