//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  unitResFile,unitResourceDetailsjbggpă\[X̃rbg}bv擾
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N1130 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, StrUtils;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    Image1: TImage;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
    FResouceFile : string;
    FResType     : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  unitResFile,
  unitResourceDetails;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'DlgSetRes.dres';
  Image1.AutoSize :=True;
end;

//=============================================================================
//  \[X̗
//  ł RT_BITMAP Ƃ(܂rbg}bv)
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LResModule : TResModule;
  LResIndex  : Integer;
  LresIDName : string;
begin
  Image1.Picture.Assign(nil);

  FResouceFile := ExpandFileName(Trim(Edit1.Text));
  FResType     := UIntToStr(Cardinal(RT_BITMAP));

  ListBox1.Items.Clear;
  ListBox1.Items.BeginUpdate;

  LResModule := TResModule.Create;
  LResModule. LoadFromFile(FResouceFile);
  try
    //\[X̗
    for LResIndex := 0 to LResModule.ResourceCount - 1 do begin
      if LResModule.ResourceDetails[LResIndex].ResourceType = FResType then begin
        LresIDName := LResModule.ResourceDetails[LResIndex].ResourceName;
        ListBox1.Items.Add(LresIDName);
      end;
    end;
  finally
    FreeAndNil(LResModule);
  end;

  ListBox1.Items.EndUpdate;
  Label1.Caption := IntToStr(ListBox1.Items.Count);
end;

//=============================================================================
//  ListBox1OnClickCxg
//  Xg{bNXItemNbN炻̃\[XǂݏoTImageɕ\
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
var
  LIndex          : Integer;
  LResModule      : TResModule;
  LResIDName      : string;
  LResIndex       : Integer;
  LresStream      : TBytesStream;
  LPictStream     : TBytesStream;
  LBMCheckStr     : array[0..1] of AnsiChar;
  LInfoHeaderSize : DWORD;
  LresInfoHeader  : TBitmapInfoHeader;
  LBmpFileHeader  : TBitmapFileHeader;
  LWICImage       : TWICImage;
  LFlag           : Boolean;
begin
  Image1.Picture.Assign(nil);
  LIndex := ListBox1.ItemIndex;
  if FResouceFile = '' then exit;
  if LIndex < 0 then exit;

  LresStream := TBytesStream.Create;
  LResModule := TResModule.Create;
  try
    LResModule. LoadFromFile(FResouceFile);
    //w肵\[X̃CfbNX擾
    LFlag := False;
    for LResIndex := 0 to LResModule.ResourceCount - 1 do begin
      if LResModule.ResourceDetails[LResIndex].ResourceType = FResType then begin
        LResIDName := LResModule.ResourceDetails[LResIndex].ResourceName;
        if LresIDName = ListBox1.Items[LIndex] then begin
          LIndex := LResIndex;
          LFlag  := True;
          Break;
        end;
      end;
    end;
    if LFlag = False then exit;

    //̃CfbNX̃\[XTMemoryStreamɕۑ
    LresStream.Clear;
    LResModule.ResourceDetails[LIndex].Data.SaveToStream(LresStream);

    LresStream.Position := 0;
    LresStream.ReadBuffer(LInfoHeaderSize, 4);

    //rbg}bṽt@Cwb_tĂrbg}bv\[X
    //̃`FbN
    LresStream.Position := 0;
    LresStream.Read(LBMCheckStr, 2);
    if LBMCheckStr <> 'BM' then LBMCheckStr := '';

    LPictStream := TBytesStream.Create;
    LWICImage   := TWICImage.Create;
    try
      //t@Cwb_񂪂Ȃrbg}bvf[^
      if (LBMCheckStr = '') and (LInfoHeaderSize <= SizeOf(TBitmapV5Header)) then begin
        //wb_ǂݏo
        LresStream.Position := 0;
        LresStream.Read(LresInfoHeader, SizeOf(LresInfoHeader));

        //TBitmapFileHeaderwb_ɒlZbg
        //$4D42BMASCIIR[h(gGfBAȂ̂$42B,$4DM)
        LBmpFileHeader.bfType      := $4D42;
        LBmpFileHeader.bfSize      := LresStream.Size;
        LBmpFileHeader.bfReserved1 := 0;
        LBmpFileHeader.bfReserved2 := 0;
        LBmpFileHeader.bfOffBits   := SizeOf(TBitmapFileHeader);

        //ʂTMemoryStreamTBitmapFileHeadeȑ
        //̌ɓǂݏo\[X̃f[^ǉ
        LPictStream.Position := 0;
        LPictStream.Write(LBmpFileHeader, SizeOf(TBitmapFileHeader));
        LresStream.Position := 0;
        LPictStream.CopyFrom(LresStream, LresStream.Size);
      end else begin
        //ǂݏof[^ʂTMemoryStreamɃRs[
        LPictStream.Position := 0;
        LresStream.Position  := 0;
        LPictStream.CopyFrom(LresStream, LresStream.Size);
      end;

      //摜̕\
      LWICImage.LoadFromStream(LPictStream);
      Image1.Picture.Assign(LWICImage);
    finally
      FreeAndNil(LPictStream);
      FreeAndNil(LWICImage);
    end;
  finally
    FreeAndNil(LResModule);
    FreeAndNil(LresStream);
  end;
end;

end.
